/*
// Created by Kaan on 9.04.2021.
*/

#include <stdio.h>
#include <stdlib.h>
#include <SDL2/SDL.h>
#include <time.h>
#include <SDL2/SDL_ttf.h>
#include "timer.h"
#include "GAME.h"
#include "personnage.h"

clock_t begin;
int time_spent;

char timerString[10];

void init_timer(){
    TTF_Init();
    begin=clock();
}

/*!
 * \fn SDL_Texture * query_timer(Personnage *hero, SDL_Renderer *renderer, SDL_Rect* timer_rect, SDL_Window * window, int seconde, int* time_remaining)
 * \brief This function calculate and query a timer display
 *
 * \param [in] hero a hero pointer
 * \param [in] renderer the SDL renderer
 * \param [in] timer_rect the SDL rect of timer
 * \param [in] window the SDL window
 * \param [in] seconde the time to count down
 * \param [in] time_remaining the pointer to the time remaining
 */

SDL_Texture * query_timer(Personnage *hero, SDL_Renderer *renderer, SDL_Rect* timer_rect, SDL_Window * window, int seconde, int* time_remaining){
    SDL_Color white = {255, 255, 255};  //  text's color
    time_spent = (clock() - begin) / CLOCKS_PER_SEC;
    *time_remaining=seconde-time_spent;
	sprintf(timerString,"%d",*time_remaining);
    TTF_Font* Sans = TTF_OpenFont("../ressource/batmfa__.ttf", 8); //font style and sets a size
	
    TTF_SetFontStyle(Sans, 2);
    SDL_Surface* tim = TTF_RenderText_Solid(Sans, timerString , white);
    SDL_Texture* texture_timer = SDL_CreateTextureFromSurface(renderer, tim);
    SDL_FreeSurface(tim);
	
	
    // draw the image to the window
    if (!texture_timer)
    {
        printf("error creating texture: %s\n", SDL_GetError());
        SDL_DestroyRenderer(renderer);
        SDL_DestroyWindow(window);
        SDL_Quit();
        return NULL;
    }

    timer_rect->x = 580;  //controls the rect's x coordinate
    timer_rect->y = 5; // controls the rect's y coordinte
    timer_rect->w = 40; // controls the width of the rect
    timer_rect->h = 30; // controls the height of the rect

    if(*time_remaining==0){
        show_image_in_time(renderer,window,"../ressource/timeout.png",1000);
        hero->result=LOSE;
    }
	
	TTF_CloseFont(Sans);
    return texture_timer;
}

